<!DOCTYPE html>
<html>
<head>
	<title>SR-71 Submersible ROV control panel</title>
	<link rel="stylesheet" type="text/css" href="static/style.css">
</head>
<body>
	<div id="container">
		<header>
			<h1>SR-71 Submersible ROV control panel</h1>
		</header>
		<main>
			<section>
				<h2>Remote Control</h2>
				<h4>Controls disconnected during autonomous mission</h4>
				<div id="controls">
					<div id="parent">
				      <div id="joystick"></div>
				      <div id="arrow-top"></div>
				      <div id="arrow-right"></div>
				      <div id="arrow-bottom"></div>
				      <div id="arrow-left"></div>
				  </div>
				  <script>
				    const parent = document.querySelector('#parent');
				    const joystick = document.querySelector('#joystick');
				    let isDragging = false;

				    joystick.addEventListener('mousedown', (event) => {
				      isDragging = true;
				      updateJoystickPosition(event.clientX, event.clientY);
				    });

				    document.addEventListener('mousemove', (event) => {
				      if (isDragging) {
				        updateJoystickPosition(event.clientX, event.clientY);
				      }
				    });

				    document.addEventListener('mouseup', () => {
				      isDragging = false;
				      joystick.style.left = "75px";
				      joystick.style.top = "75px";
				    });

				    function updateJoystickPosition(clientX, clientY) {
				      const parentRect = parent.getBoundingClientRect();
				      const x = clientX - parentRect.left - joystick.offsetWidth / 2;
				      const y = clientY - parentRect.top - joystick.offsetHeight / 2;
				      const maxX = parentRect.width - joystick.offsetWidth;
				      const maxY = parentRect.height - joystick.offsetHeight;
				      joystick.style.left = `${Math.min(Math.max(0, x), maxX)}px`;
				      joystick.style.top = `${Math.min(Math.max(0, y), maxY)}px`;
				    }
				  </script>
				 	<div class="slider-container">
						<input type="range" min="0" max="100" value="70" class="slider" id="throttle">
					</div>
					<div id="throttle-indicator"></div>
				</div>
			</section>
			<section>
				<h2>Live Camera Feed</h2>
				<img id="video" src="../cam1.jfif" alt="ROV camera feed">
					<script>
						let currentImage = 1;

						function loadImage() {
							const image = document.querySelector('#video');
							image.src = `static/cam${currentImage}.jfif`;
							currentImage = (currentImage % 25) + 1;
							setTimeout(loadImage, 30000);
						}

						loadImage();

						var slider = document.getElementById("throttle");

						setInterval(function() {
							var value = Math.floor(Math.random() * 51) + 50;
							slider.value = value;
						}, 5000);
					</script>
			</section>
			<section>
				<h2>Sensor Data</h2>
				<div id="sensors">
					<p>Depth: <span id="depth">0</span> meters</p>
					<p>Temperature: <span id="temperature">0</span> &deg;C</p>
					<p>Pressure: <span id="pressure">0</span> bar</p>
				</div>
					<script>
						var liveDataElement = document.getElementById("sensors");

						function updateLiveData() {
							// Make a GET request to the URL to retrieve the live data
							fetch("/live-data?ipaddress=127.0.0.1:9101&query=sensors")
								.then(response => response.text()) // Convert the response to text
								.then(data => {
									liveDataElement.innerHTML = data; // Set the live data element's innerHTML to the retrieved data
								})
								.catch(error => console.error(error));
						}

						// Update the live data every 3 seconds
						setInterval(updateLiveData, 3000);
					</script>
			</section>
		</main>
		<footer>
			<p>Copyright &copy; 2023 SubSea Robotics</p>
			<!-- CTF{nobody_ever_checks_if_we_changed_the_default_password} -->
		</footer>
	</div>
</body>
</html>
